/*Created by Veselin Georgiev on 2006-05-30 */
/* Glassy.pov */

#declare CUP_X=0;
#declare CUP_Z=3;
#declare CUP_Y=-2;
#declare CUP_Radius=1;
#declare CUP_RADINC=0.3;
#declare CUP_MinY=-4;
#declare CUP_MaxY=-1.6;
#declare CUP_Wall=0.1;
#declare LIGHT_Q=8;


global_settings {
 max_trace_level 10
 //ambient_light 0.5
 ambient_light 0.15
 
 radiosity {
  brightness 1.0
  count 160
 }
 
 
 /*photons {
  count 500
  media 100
 }*/
}


/*
*/

#macro chemglass()
	texture {
//		pigment { rgb <1,1,1> }
		pigment { rgbt <1,1,0,0.9>}
	}
	finish { diffuse 0.3 brilliance 0.1 specular 0.4 crand 0.01 ambient 0.2}
	
	interior { 
		ior 1.5
		//dispersion 1.1
		//dispersion_samples 50
	}
	
	/*photons {
		target HQ
		refraction on
		reflection on
	}*/
	
#end

#macro xplastic()
	texture {
		pigment { rgb <0.25, 0.2, 0.25> }
		finish {
			crand 0.1 ambient 0.5 diffuse 1.0 specular 0.1
		}
	}
#end


union {
	// The chemical stuff
	isosurface {
	
		function {
			sqrt((y-CUP_Y)*(y-CUP_Y)+(z-CUP_Z)*(z-CUP_Z)) - 0.5
			+ (cos(15*sqrt(abs(x - CUP_X))) + 1.0)*0.22
			+ abs(pow(abs(x-CUP_X)/1.5, 15))*6.0
		}
		
	/*	function {
			sqrt((y-CUP_Y)*(y-CUP_Y)+(z-CUP_Z)*(z-CUP_Z)) - 0.5
		}*/
		
		contained_by {
			box {
				<CUP_X - 1.5, CUP_Y - 0.5, CUP_Z - 0.5>
				<CUP_X + 1.5, CUP_Y + 0.5, CUP_Z + 0.5>
			}
		}
		max_gradient 42.0
		//max_gradient 1
		
		chemglass()
	}
	
	// Chem extents
	cylinder {
		<CUP_X - 1.7, CUP_Y, CUP_Z>,
		<CUP_X - 1.1, CUP_Y, CUP_Z>, 0.1
		chemglass()
	}
	
	cylinder {
		<CUP_X + 1.1, CUP_Y, CUP_Z>,
		<CUP_X + 1.7, CUP_Y, CUP_Z>, 0.1
		chemglass()
	}
		
	// chem rods
	cylinder {
		<CUP_X - 1.65, CUP_Y+0.05, CUP_Z>,
		<CUP_X - 1.65, -4, CUP_Z> 0.12
		xplastic()
	}
	
	cylinder {
		<CUP_X + 1.65, CUP_Y+0.05, CUP_Z>,
		<CUP_X + 1.65, -4, CUP_Z> 0.12
		xplastic()
	}
}

// The wood table
box {
	<-10, -4, -15>
	<10, -6, 15>
	texture {
		//pigment { rgb<1.0, 0.5, 0.1> }
		pigment { wood turbulence 0.1 scale 0.25}
	}
	finish { ambient 1.0 diffuse 1.0 specular 0.1 }
}

// The paper list
box {
	<0, 0, 0.01>
	<1, 1, 0.00>
	texture {
		pigment { 
			image_map { png "papershit.png" interpolate 4 }
			
		}
		finish { ambient 1.0 diffuse 1.0 specular 0.3}
	}
	scale<4,3,1>
	rotate <270, 0, 0>
	rotate <0, 127, 0>
	translate <2, -4, 2>
	
}

// The photo supporter
superellipsoid {
	<0.2, 0.2>
	texture {
		pigment { rgb <0.7, 0.3, 0.1> }
		finish { ambient 1.0 diffuse 1.0 specular 0.3}
	}
	rotate <0, 45, 0>
	translate <5, -3, 1>
}

// The photo with the frame
union {
	difference {
		box {
			<-0.1, -0.1, -1.1>
			<1.1, 1.1, -0.9>
			pigment { wood turbulence 0.1 scale 0.25 }
			finish { ambient 0.1 diffuse 0.5 specular 0.5 }
		}
		superellipsoid {
			<0.2, 0.2>
			scale <0.5, 0.5, 1>
			translate <0.5, 0.5,0>
		}
	}
	box {
		<0, 0, -1>
		<1, 1, -0.99>
		texture {
			pigment { 
				image_map { png "ivet.png" interpolate 4 once}
				
			}
			finish { ambient 1.0 diffuse 1.0 specular 0.3 reflection 0.1 }
		}
	}
	scale <2.66, 2, 1>
	rotate <-15, 0, 0>
	rotate <0, -75, 0>
	
	translate <2, -3.5, 1>
	
}

#macro WALLOPTS()
        pigment {
                granite
		color_map {
			[0.1 rgb <0.9,0.9,0.9>]
			[0.7 rgb <1,1,1>]
		}
		
        }
	
        finish {
                reflection 0.05
                crand 0.1
		ambient 0.5 diffuse 1.0 specular 0.15
        }
	
#end


// The Wall
union {
	difference {
		box {
			<-10, -4, -1>
			<10, 25, -2>
			WALLOPTS()
		}
		union {
			box {
				<-9, -1, -0.9>
				<3, 7, -2.1>
				WALLOPTS()
			}
			superellipsoid {
				<0.2, 0.2>
				scale <6.5, 0.5, 1>
				translate <-3, -1.4, -1.0> 
			}
			
			superellipsoid {
				<0.2, 0.2>
				scale <0.25, 3, 1>
				translate<3, 1.2, -1>
			}
		}
	}
	
	box {
		<+10, -4, -1>
		<+11, 25, 15>
		WALLOPTS()
	}
	//The windowframe
	superellipsoid {
		<0.2, 0.2>
		pigment {
			rgb <1,1,1>
		}
		
		finish {
			reflection 0.05
			crand 0.1
			ambient 0.5 diffuse 1.0 specular 0.15
		}
	
		
		scale <6.5, 0.5, 1>
		translate <-3, -1.4, -1.0> 
	}
	
	superellipsoid {
		<0.2, 0.2>
		pigment {
			rgb <1,1,1>
		}
		
		finish {
			reflection 0.05
			crand 0.1
			ambient 0.5 diffuse 1.0 specular 0.15
		}
	
		scale <0.25, 3, 1>
		translate<3, 1.2, -1>
	}

}



// The sky
plane{
	<0,60,0>,1 hollow
       texture{ pigment{ bozo turbulence 0.76
                         color_map { [0.5 rgb <0.30, 0.30, 1.0>*1]
                                     [0.6 rgb <1,1,1>]
                                     [1.0 rgb <0.2,0.2,0.2>]}
				scale 3.5 translate<10,0,9>
			}
		finish {ambient 10 diffuse 0} }
	scale 10000
}

/* Lights & Camera */
light_source {
	<-25, 50, -75>, <1.0,1.0,1.0>
	area_light <1,0,0>, <0,0,1>, LIGHT_Q, LIGHT_Q
}

camera {
	location <-1, -2.5, +7>
	look_at <1,-1.5,-1>
	angle 75
	
	aperture 0.24
	blur_samples 256
	focal_point <CUP_X,CUP_Y,CUP_Z>
	
}
